﻿using System;
using System.Collections.Generic;
using System.Text;

namespace TGC.RadioButtonUtil
{
    public class RadioBtnContainerEventArgs : EventArgs
    {
        private System.Windows.Forms.RadioButton button = null;
        private int index = 0;
        private bool isOptionSelected = false;

        private RadioBtnContainerEventArgs()
        { }

        public static RadioBtnContainerEventArgs CreateForNoneSelected()
        {
            // fields initialized to defaults...'
            return new RadioBtnContainerEventArgs();
        }

        public static RadioBtnContainerEventArgs CreateFromContainer(RadioButtonContainer parent)
        {
            RadioBtnContainerEventArgs result = new RadioBtnContainerEventArgs();
            result.button = parent.CurrentOption;

            if (result.button != null)
            {
                result.index = parent.CurrentOptionIndex;
                result.isOptionSelected = true;
            }

            return result;
        }

        public System.Windows.Forms.RadioButton Button
        {
            get { return button; }
        }

        public bool IsOptionSelected
        {
            get { return isOptionSelected; }
        }

        public int Index
        {
            get
            {
                if (!isOptionSelected)
                    throw new InvalidOperationException(
                        "None of the radio buttons is selected! Always check if IsOptionSelected==false or if Button==null."
                        );

                return index;
            }
        }
    }
}
