﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace TGC.RadioButtonUtil
{
    public class RadioBtnGroupEventArgs : EventArgs
    {
        private RadioButton button = null;
        private int index = 0;
        private bool isOptionSelected = false;

        private RadioBtnGroupEventArgs()
        { }

        public static RadioBtnGroupEventArgs CreateForNoneSelected()
        {
            // fields initialized to defaults...'
            return new RadioBtnGroupEventArgs();
        }

        public static RadioBtnGroupEventArgs CreateFromGroup(RadioButtonGroup group)
        {
            RadioBtnGroupEventArgs result = new RadioBtnGroupEventArgs();
            result.button = group.Current;

            if (result.button != null)
            {
                result.index = group.CurrentIndex;
                result.isOptionSelected = true;
            }

            return result;
        }

        public RadioButton Button
        {
            get { return button; }
        }

        public bool IsOptionSelected
        {
            get { return isOptionSelected; }
        }

        public int Index
        {
            get
            {
                if (!isOptionSelected)
                    throw new InvalidOperationException(
                        "None of the radio buttons is selected! Always check if IsOptionSelected==false or if Button==null."
                        );

                return index;
            }
        }
    }
}
